/**
 * Copyright (C) 2012 Linutop SAS <http://www.linutop.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef WK_PL_LOOP_H
#define WK_PL_LOOP_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <glib.h>

typedef struct {
    int id;

    int priority;
    gboolean idle;

    int start_year;
    int start_month;
    int start_day;
    char start_date[11];

    int end_year;
    int end_month;
    int end_day;
    char end_date[11];

    int start_hour;
    int start_min;
    char start_time[6];

    int end_hour;
    int end_min;
    char end_time[6];

    int weekdays;

    /* pointers to WkSlideshowItem held in an extern GHashTable */
    GSList *data;
} WkPlLoop;

WkPlLoop *wk_pl_loop_new ();
gboolean wk_pl_loop_load_from_xml_data (WkPlLoop *loop,
                                        const gchar **attribute_names,
                                        const gchar **attribute_values);

/* void wk_pl_loop_add_data (WkPlLoop *loop, WkSlideshowItem *item); */
#define wk_pl_loop_add_data(loop,item) (loop)->data = g_slist_append ((loop)->data, item)

void wk_pl_loop_free (WkPlLoop *loop);

gboolean wk_pl_loop_fits_now (WkPlLoop *loop);

#ifdef WITH_DEBUG
void wk_pl_loop_print (WkPlLoop *loop);
void wk_pl_loop_print_data (WkPlLoop *loop);
#endif

#endif /* !WK_PL_LOOP_H */

