/**
 * Copyright (C) 2012 Linutop SAS <http://www.linutop.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef WK_PL_H
#define WK_PL_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <glib.h>

#include "main.h"
#include "wk-pl-loop.h"
#include "wk-slideshow-item.h"

typedef struct {
    GHashTable *loops;
    GHashTable *data;
    WkPlLoop *selected_loop;
    gint current_id;
} WkPl;

WkPl *wk_pl_new ();
void wk_pl_free (WkPl *pl);
void wk_pl_reset (WkPl *pl);

gboolean wk_pl_set_from_xml (WkPl *pl, const gchar *xml);
gboolean wk_pl_set_from_list (WkPl *pl, const gchar *str);

void wk_pl_select (WkPl *pl);

void wk_pl_add_loop (WkPl *pl, WkPlLoop *loop);
void wk_pl_add_data (WkPl *pl, WkSlideshowItem *item);

void wk_pl_set_loop_idle (WkPl *pl, WkPlLoop *loop);

void wk_pl_set_cache   (WkPl *pl,
                        const gchar *data_dir,
                        const gchar *etga_dir);

#ifdef WITH_DEBUG
void wk_pl_print (WkPl *pl);
#endif

#endif /* !WK_PL_H */
